package com.tofly.feesapi.wxgl.wechatofficalacctmgt.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.WxDbsq;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.dto.WxCommonDto;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity.vo.WxDbsqVo;
import com.tofly.feesapi.wxgl.wechatofficalacctmgt.service.WxDbsqService;
import lombok.AllArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;

@RestController
@RequestMapping("/wxdbsq")
@Api(tags = "微信-低保申请接口")
public class WxDbsqController {

    @Autowired
    private WxDbsqService wxDbsqService;

    @GetMapping("/getpage")
    @ApiOperation(value = "自定义分页查询")
    public ResultRespone<Page<WxDbsqVo>> getWxDbsqPage(Page page, @ModelAttribute WxCommonDto dto) {
        ResultRespone<Page<WxDbsqVo>> resultRespone = new ResultRespone<>();
        try {
            Page<WxDbsqVo> wxPage = wxDbsqService.getWxDbsqPage(page, dto);
            resultRespone.setCode(1);
            resultRespone.setResult(wxPage);
        } catch (RuntimeException e) {
            resultRespone.setCode(-1);
            resultRespone.setMessage(e.getMessage());
        }
        return resultRespone;
    }


    @GetMapping("/page")
    @ApiOperation(value = "分页查询")
    public ResultRespone getWxDbsqPage(Page page, @ModelAttribute WxDbsq wxDbsq) {
        return ResultRespone.success(wxDbsqService.page(page, Wrappers.query(wxDbsq)));
    }


    @GetMapping("/{id}")
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id") String id) {
        return ResultRespone.success(wxDbsqService.getById(id));
    }


    @ApiOperation(value = "新增微信-低保申请")
    @PostMapping
    public ResultRespone save(@RequestBody WxDbsq wxDbsq) {
        return ResultRespone.success(wxDbsqService.save(wxDbsq));
    }

    @ApiOperation(value = "修改微信-低保申请")
    @PutMapping
    public ResultRespone updateById(@RequestBody WxDbsq wxDbsq) {
        return ResultRespone.success(wxDbsqService.updateById(wxDbsq));
    }
    /**
     * 修改微信-低保申请
     */
    @ApiOperation(value = "修改微信-低保申请")
    @PostMapping("/update")
    public ResultRespone<Boolean> update(@RequestBody WxDbsq update) {
        return ResultRespone.success(wxDbsqService.updateWxDbsq(update));
    }

    @ApiOperation(value = "通过ID删除微信-低保申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}")
    public ResultRespone removeById(@PathVariable String id) {
        return ResultRespone.success(wxDbsqService.removeById(id));
    }


    @ApiOperation(value = "通过ID批量删除微信-低保申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds")
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(wxDbsqService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
